uab.modules.OvalLayoutManager = uabLayoutManager:NewModule("uab.Oval")
uab.modules.OvalLayoutManager.localizedName = "Oval"
uab.modules.OvalLayoutManager.layouts = {}
uab.modules.OvalLayoutManager.defaultDB = {
    disabled = nil,
    settings = {
    },
}

function uab.modules.OvalLayoutManager:OnInitialize()
    self.super.OnInitialize(self)
end

function uab.modules.OvalLayoutManager:OnDisable()
    --[[
    Called when the manager is disabled.  This could happen
    when profiles change, or the manager is disabled and then re-enabled.
    
    We clear out the loaded layouts so that when we are
    enabled the next time, we have no layouts, and we have
    to load them again from our DB.
    --]]

    for name, val in pairs(self.layouts) do
        self.layouts[name] = nil
    end
end

function uab.modules.OvalLayoutManager:GetLayout(contextName)
    if not self.layouts[contextName] then
        local useoldconfig

        if not self.db.profile.settings[contextName] then
            self.db.profile.settings[contextName] = {}
            useoldconfig = contextName == "main"
        end

        self.layouts[contextName] = uab.modules.OvalLayoutManager.Layout:new(contextName, self.db.profile.settings[contextName])
        if useoldconfig and uab.db.profile.layoutSettings and uab.db.profile.layoutSettings[self.name] then
            self.layouts[contextName]:SetSettings(uab.db.profile.layoutSettings[self.name])
        end
        if uab.db.profile.layoutSettings then
            uab.db.profile.layoutSettings[self.name] = nil
        end
    end

    return self.layouts[contextName]
end

function uab.modules.OvalLayoutManager:GetDisplayName()
	return self.localizedName
end

