uab.modules.uabStatus_MainDebuffs = uabUnitStatus:NewModule("Main Debuffs")
uab.modules.uabStatus_MainDebuffs.aura = AceLibrary("SpecialEvents-Aura-2.0")
uab.modules.uabStatus_MainDebuffs.defaultDB = {
    disabled = nil,
    curse = {
        disabled = nil,
        priority = 50,
        color = { r = 0.75, g = 0, b = 1, a = 1, },
	},
    disease = {
        disabled = nil,
        priority = 50,
        color = { r = 1,    g = 0.75, b = 0, a = 1, },
	},
    magic = {
        disabled = nil,
        priority = 50,
        color = { r = 0,    g = 0.25, b = 1, a = 1, },
	},
    poison = {
        disabled = nil,
        priority = 50,
        color = { r = 0,    g = 1,    b = 0, a = 1, },
	},
}

function uab.modules.uabStatus_MainDebuffs:OnInitialize()
    self.super.OnInitialize(self)

	self:RegisterUnitStatus("Debuff: Curse")
	self:RegisterUnitStatus("Debuff: Disease")
	self:RegisterUnitStatus("Debuff: Magic")
	self:RegisterUnitStatus("Debuff: Poison")
end

function uab.modules.uabStatus_MainDebuffs:OnEnable()
end

function uab.modules.uabStatus_MainDebuffs:OnDisable()
end

function uab.modules.uabStatus_MainDebuffs:IsStatusGained(name, unit, action)
	if name == "Debuff: Curse" then
		return self.aura:UnitHasDebuffType(unit, "Curse")
	elseif name == "Debuff: Disease" then
	    return self.aura:UnitHasDebuffType(unit, "Disease")
	elseif name == "Debuff: Magic" then
	    return self.aura:UnitHasDebuffType(unit, "Magic")
	elseif name == "Debuff: Poison" then
	    return self.aura:UnitHasDebuffType(unit, "Poison")
	end
end

function uab.modules.uabStatus_MainDebuffs:OptionsForUnitStatus(name)
	if name == "Debuff: Curse" then
		return self.db.profile.curse
	elseif name == "Debuff: Disease" then
		return self.db.profile.disease
	elseif name == "Debuff: Magic" then
		return self.db.profile.magic
	elseif name == "Debuff: Poison" then
		return self.db.profile.poison
	end
end

function uab.modules.uabStatus_MainDebuffs:CreateUnitStatusOptions()
    local args = {}

    args = {
        type = 'group',
        name = "Debuff",
        desc = "Configure the options for debuff unit status values",
        args = {
            enabled = {
                type = 'toggle',
                name = "Enabled",
                desc = "When checked, enable the use of the debuff unit status values",
                order = 1,
                get = function()
                    return not self.db.profile.disabled
                end,
                set = function(v)
                    self.db.profile.disabled = not v
                    self.core.core.main:FrameGroupsChanged()
                end,
            },

            spacing3 = {
                name = " ",
                type = 'header',
                order = 5,
            },

        },
    }

    args.args["curse"] = self:CreateUnitStatusOption(self.db.profile.curse, "Debuff: Curse", "Debuff: Curse")
    args.args["curse"].order = 10

    args.args["disease"] = self:CreateUnitStatusOption(self.db.profile.disease, "Debuff: Disease", "Debuff: Disease")
    args.args["disease"].order = 20

    args.args["magic"] = self:CreateUnitStatusOption(self.db.profile.magic, "Debuff: Magic", "Debuff: Magic")
    args.args["magic"].order = 30

    args.args["poison"] = self:CreateUnitStatusOption(self.db.profile.poison, "Debuff: Poison", "Debuff: Poison")
    args.args["poison"].order = 40

    return args
end
